/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   app.h
Author(s)   :   Thomas Cheng
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application header file
Revision    :   1.1
Note        :   None
===========================================================================
*/              


#ifndef _APP_H_
#define _APP_H_

#include "include\uifunc.h"
#include "include\uidef.h"
#include "include\appfunc.h"

extern ObjectID *object_array;

/*****************************************************************
******************** FORM MAIN MENU **********************
*****************************************************************/
#define FORM_MAIN_MENU							0
#define TABLE_MAIN_MENU							1

#define APP_ALARMGR                             1

#define APP_PHONEBOOK                           2
#define APP_CALCULATOR                          3
#define APP_SCHEDULER                           4
#define APP_EXPENSE                             5
#define APP_PC_SYNC                             6
#define APP_EMAIL                               7
#define APP_MEMO                                8
#define APP_VOICE_MEMO                          9
#define APP_SYSETUP                             10
#define APP_SKETCH                              11
#define APP_TO_DO_LIST                          12
#define APP_JOT                                 13
#define APP_PUZZLE_0                            14
#define APP_PUZZLE_1                            15
#define APP_PUZZLE_2                            16

#define BITMAP_BAT0                             17
#define BITMAP_BAT1                             18
#define BITMAP_BAT2                             19
#define BITMAP_BAT3                             20
#define STRING_TIME                             21
#define SCROLLBAR_MAIN_MENU                     22

extern UWORD tmr;

#endif
