#include "include\uartmgr.h"
#include "include\syncfx.h"
#include "include\comctrl.h"
#include "include\pdasync.h"
#include "include\synctout.h"
#include "include\combuf.h"
#include "include\app.h"
#include "include\lcddebug.h"
#define EL32(x)         (x <<24 | (x &0xff00) <<8 | (x &0xff0000) >>8 | x>>24)

DatabaseID pb_dbid;

void PhonebookDatabaseInit()
{

        DatabaseID pb_dbid;
	RecordID rec_id;
	SHORT i = 0, j = 0;
		
	BYTE personal_cate[15];
	BYTE business_cate[10];

	BYTE *personal_first_name[15];
	BYTE *business_first_name[10];

	BYTE *personal_last_name[15];
	BYTE *business_last_name[10];

	BYTE *personal_name[15];
	BYTE *business_name[10];

	BYTE *personal_tel[15];
	BYTE *business_tel[10];

	BYTE *personal_title[15];
	BYTE *business_title[10];


        if(DataFindDB((BYTE*) "Phonebook Database", &pb_dbid) == TRUE)
                return;

	/* setting up dataaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa */
	for (i = 0; i <15; i++)
		personal_cate[i] = 4;
	for (i = 0; i <10; i++)
		business_cate[i] = 1;

	for (i = 0; i <15; i++)
	{
	
                personal_first_name[i] = (BYTE*)qmalloc(36*sizeof(BYTE));
               //lcdprintf(" first_name26 = %08x ", personal_first_name[i]);
                personal_last_name[i]  = (BYTE*)qmalloc(36*sizeof(BYTE));
               //lcdprintf(" last_name26 = %08x ", personal_last_name[i]);
                personal_name[i]       = (BYTE*)qmalloc(52*sizeof(BYTE));
               //lcdprintf(" name42 = %08x ", personal_name[i]);
                personal_tel[i]            = (BYTE*)qmalloc(36*sizeof(BYTE));
               //lcdprintf(" tel26 = %08x ", personal_tel[i]);
                personal_title[i]          = (BYTE*)qmalloc(70*sizeof(BYTE));
               //lcdprintf(" title60 = %08x ", personal_title[i]);
	}


	for (i = 0; i <10; i++)
	{
	
                business_first_name[i] = (BYTE*)qmalloc(36*sizeof(BYTE));
                business_last_name[i]  = (BYTE*)qmalloc(36*sizeof(BYTE));
                business_name[i]           = (BYTE*)qmalloc(42*sizeof(BYTE));
                business_tel[i]            = (BYTE*)qmalloc(26*sizeof(BYTE));
                business_title[i]          = (BYTE*)qmalloc(60*sizeof(BYTE));
	}


	strcpy(personal_first_name[0],"Henry");
	strcpy(personal_first_name[1],"Wendy");
	strcpy(personal_first_name[2],"Kenny");
	strcpy(personal_first_name[3],"David");
	strcpy(personal_first_name[4],"Kenni");
	strcpy(personal_first_name[5],"Yogi");
	strcpy(personal_first_name[6],"Fiona");
	strcpy(personal_first_name[7],"Brian");
	strcpy(personal_first_name[8],"Rosita");
	strcpy(personal_first_name[9],"May");
	strcpy(personal_first_name[10],"U2");
	strcpy(personal_first_name[11],"Chucky");
	strcpy(personal_first_name[12],"CoCo");
	strcpy(personal_first_name[13],"Rubbish");
	strcpy(personal_first_name[14],"Trash");


	strcpy(business_first_name[0],"Wilson");
	strcpy(business_first_name[1],"Helen");
	strcpy(business_first_name[2],"Patrick");
	strcpy(business_first_name[3],"John");
	strcpy(business_first_name[4],"Mary");
	strcpy(business_first_name[5],"Joe");
	strcpy(business_first_name[6],"KK");
	strcpy(business_first_name[7],"S.K.");
	strcpy(business_first_name[8],"Dicky");
	strcpy(business_first_name[9],"Ricky");


	strcpy(personal_last_name[0],"FOK");
	strcpy(personal_last_name[1],"Siu");
	strcpy(personal_last_name[2],"Ng");
	strcpy(personal_last_name[3],"Lo");
	strcpy(personal_last_name[4],"FOK");
	strcpy(personal_last_name[5],"Yuen");
	strcpy(personal_last_name[6],"FOK");
	strcpy(personal_last_name[7],"Wah");
	strcpy(personal_last_name[8],"Ng");
	strcpy(personal_last_name[9],"Yip");
	strcpy(personal_last_name[10],"FOK");
	strcpy(personal_last_name[11],"FOK");
	strcpy(personal_last_name[12],"FOK");
	strcpy(personal_last_name[13],"FOK");
	strcpy(personal_last_name[14],"FOK");

	strcpy(business_last_name[0],"Chung");
	strcpy(business_last_name[1],"Wong");
	strcpy(business_last_name[2],"Wang");
	strcpy(business_last_name[3],"Chan");
	strcpy(business_last_name[4],"Lee");
	strcpy(business_last_name[5],"Lee");
	strcpy(business_last_name[6],"Wong");
	strcpy(business_last_name[7],"Yiu");
	strcpy(business_last_name[8],"Chan");
	strcpy(business_last_name[9],"Lam");

	strcpy(personal_name[0],"Henry FOK");
	strcpy(personal_name[1],"Wendy Siu");
	strcpy(personal_name[2],"Kenny Ng");
	strcpy(personal_name[3],"David Lo");
	strcpy(personal_name[4],"Kenni FOK");
	strcpy(personal_name[5],"Yogi Yuen");
	strcpy(personal_name[6],"Fiona FOK");
	strcpy(personal_name[7],"Brian Wah");
	strcpy(personal_name[8],"Rosita Ng");
	strcpy(personal_name[9],"May Yip");
	strcpy(personal_name[10],"Chucky FOK");
	strcpy(personal_name[11],"CoCo FOK");
	strcpy(personal_name[12],"Rubbish FOK");
	strcpy(personal_name[13],"Trash FOK");
	strcpy(personal_name[14],"HiHi FOK");


	strcpy(business_name[0],"Wilson Chung");
	strcpy(business_name[1],"Helen Wong");
	strcpy(business_name[2],"Patrick Wang");
	strcpy(business_name[3],"John Chan");
	strcpy(business_name[4],"Mary Lee");
	strcpy(business_name[5],"Joe Lee");
	strcpy(business_name[6],"KK Wong");
	strcpy(business_name[7],"S.K. Yiu");
	strcpy(business_name[8],"Dicky Chan");
	strcpy(business_name[9],"Ricky Lam");

	strcpy(personal_tel[0],"852-123456789");
	strcpy(personal_tel[1],"9654321");
	strcpy(personal_tel[2],"999-01020304");
	strcpy(personal_tel[3],"1234567890");
	strcpy(personal_tel[4],"321-123456789");
	strcpy(personal_tel[5],"9654321");
	strcpy(personal_tel[6],"123-01020304");
	strcpy(personal_tel[7],"1234567890");
	strcpy(personal_tel[8],"1-604-1456789");
	strcpy(personal_tel[9],"649-96521");
	strcpy(personal_tel[10],"101010101010");
	strcpy(personal_tel[11],"999999999999");
	strcpy(personal_tel[12],"7777777777");
	strcpy(personal_tel[13],"6666666666");
	strcpy(personal_tel[14],"555555555555");


	strcpy(business_tel[0],"6623459");
	strcpy(business_tel[1],"123467890");
	strcpy(business_tel[2],"78323432");
	strcpy(business_tel[3],"1-601234567");
	strcpy(business_tel[4],"99999999999");
	strcpy(business_tel[5],"6623459");
	strcpy(business_tel[6],"1234567890");
	strcpy(business_tel[7],"444-78323432");
	strcpy(business_tel[8],"1-604-1234567");
	strcpy(business_tel[9],"765-99999999");

	strcpy(personal_title[0],"Mr.");
	strcpy(personal_title[1],"Ms.");
	strcpy(personal_title[2],"Mr.");
	strcpy(personal_title[3],"Mr.");
	strcpy(personal_title[4],"Mr.");
	strcpy(personal_title[5],"Ms.");
	strcpy(personal_title[6],"Mr.");
	strcpy(personal_title[7],"Ms.");
	strcpy(personal_title[8],"Mr.");
	strcpy(personal_title[9],"Ms.");
	strcpy(personal_title[10],"Ms.");
	strcpy(personal_title[11],"Mr.");
	strcpy(personal_title[12],"Ms.");
	strcpy(personal_title[13],"Mr.");
	strcpy(personal_title[14],"Ms.");

	strcpy(business_title[0],"Mr.");
	strcpy(business_title[1],"Ms.");
	strcpy(business_title[2],"Dr.");
	strcpy(business_title[3],"Mr.");
	strcpy(business_title[4],"Ms.");
	strcpy(business_title[5],"Mr.");
	strcpy(business_title[6],"Mr.");
	strcpy(business_title[7],"Ms.");
	strcpy(business_title[8],"Mr.");
	strcpy(business_title[9],"Ms.");

	/* New Database */
       //lcdprintf("\nDB man start ");
	DataNewDB((BYTE*)("Phonebook Database"),1,(BYTE*)("Phonebook Application"),&pb_dbid);
	DataOpenDB(pb_dbid,2,OPEN_RW);

	/* Open Database */
						
	DataCategorySetName(pb_dbid,0,(BYTE*)("Unfiled"));
	DataCategorySetName(pb_dbid,1,(BYTE*)("Business"));
	DataCategorySetName(pb_dbid,2,(BYTE*)("Engineering"));
	DataCategorySetName(pb_dbid,3,(BYTE*)("Office"));	
	DataCategorySetName(pb_dbid,4,(BYTE*)("Personal"));
       //lcdprintf("\nDB man end ");

	for (i = 0;i<15;i++)
	{
       //lcdprintf( " 1 ");
		DataNewRecord(pb_dbid,personal_cate[i],27,&rec_id);
printf( " 2 ");
printf("\n strlen ");
printf(" %d ", strlen(personal_first_name[i]) + 1);
		DataWriteField(pb_dbid,rec_id,0,(strlen(personal_first_name[i]) + 1),personal_first_name[i]);
printf( " 3 ");
		DataWriteField(pb_dbid,rec_id,1,(strlen(personal_last_name[i]) + 1),personal_last_name[i]);
		DataWriteField(pb_dbid,rec_id,2,(strlen(personal_name[i]) + 1),personal_name[i]);
		DataWriteField(pb_dbid,rec_id,3,1,(BYTE*)(""));
		DataWriteField(pb_dbid,rec_id,4,(strlen(personal_title[i]) + 1),personal_title[i]);
		DataWriteField(pb_dbid,rec_id,5,(strlen(personal_tel[i]) + 1),personal_tel[i]);
printf( " 4 ");
		for (j = 6; j <= 26; j++)
			DataWriteField(pb_dbid,rec_id,j,1,(BYTE*)(""));
printf( " 5 ");
		DataWriteField(pb_dbid,rec_id,15,(strlen(personal_tel[i]) + 1),personal_tel[i]);
		DataWriteField(pb_dbid,rec_id,20,10,(BYTE*)("Hong Kong"));
		DataWriteField(pb_dbid,rec_id,13,10,(BYTE*)("Hong Kong"));
printf( " 6 ");
		DataCloseRecord(pb_dbid,rec_id);
printf( " 7 ");
	}

       //lcdprintf(" a ");
	for (i = 0;i<10;i++)
	{
		DataNewRecord(pb_dbid,business_cate[i],27,&rec_id);
		DataWriteField(pb_dbid,rec_id,0,(strlen(business_first_name[i]) + 1),business_first_name[i]);
		DataWriteField(pb_dbid,rec_id,1,(strlen(business_last_name[i]) + 1),business_last_name[i]);
		DataWriteField(pb_dbid,rec_id,2,(strlen(business_name[i]) + 1),business_name[i]);
		DataWriteField(pb_dbid,rec_id,3,1,(BYTE*)(""));
		DataWriteField(pb_dbid,rec_id,4,(strlen(business_title[i]) + 1),business_title[i]);
		DataWriteField(pb_dbid,rec_id,5,(strlen(business_tel[i]) + 1),business_tel[i]);
		for (j = 6; j <= 26; j++)
			DataWriteField(pb_dbid,rec_id,j,1,(BYTE*)(""));
		DataWriteField(pb_dbid,rec_id,15,(strlen(business_tel[i]) + 1),business_tel[i]);
		DataWriteField(pb_dbid,rec_id,20,4,(BYTE*)("USA"));
		DataWriteField(pb_dbid,rec_id,13,4,(BYTE*)("USA"));
		DataCloseRecord(pb_dbid,rec_id);
	}

       //lcdprintf(" b ");

	for (i = 0; i <15; i++)
	{
		qfree(personal_first_name[i]);
		qfree(personal_last_name[i]);
		qfree(personal_name[i]);
		qfree(personal_tel[i]);
		qfree(personal_title[i]);

	}

       //lcdprintf(" c ");

	for (i = 0; i <10; i++)
	{
		qfree(business_first_name[i]);
		qfree(business_last_name[i]);
		qfree(business_name[i]);
		qfree(business_tel[i]);
		qfree(business_title[i]);
	}

       //lcdprintf(" d ");

        DataCloseDB(pb_dbid);

}



typedef struct
{
     char    yr;
     char    mon;
     char    day;
     char    hr;
     char    min;
} VOX_DATE;


/* Assign field number for database */
#define	F_time_date		0
#define	F_codedata		1
#define	F_silent_info	2
#define	F_info			3


/*****************************************************************
********************** Global Variables **************************
*****************************************************************/

/*****************************************************************
 * Function:	VoxMemoDatabaseInit
 * Purpose: 	This function is used to simulate and initialse the 
 *				the datebase in the PDA.Try to preset some records in 
 *				the database
 * Scope:		application
 * Input:		None
 * Output:		None
 * Return:		TRUE if success
 *				FALSE if no memory
 * Comment: 	This function should be called in the StartApplication() function.
*****************************************************************/
BOOLEAN VoxMemoDatabaseInit(void)
{
	USHORT i = 0;
	USHORT k = 26;					/* to be deleted after test */
DatabaseID		VoxMemo_dbid;
RecordID		VoxMemo_rec_id;

	VOX_DATE	date[26];
	BYTE *info[26];


        if(DataFindDB((BYTE*) "VoxMemoDatabase", &pb_dbid) == TRUE)
                return;


	for (i=0; i<k; i++)
		info[i]	= (BYTE*)qmalloc(40*sizeof(BYTE));

	(date[0].hr = 4);
	(date[1].hr = 23);
	(date[2].hr = 5);
	(date[3].hr = 17);
	(date[4].hr = 16);
	(date[5].hr = 14);
	(date[6].hr = 18);
	(date[7].hr = 20);
	(date[8].hr = 17);
	(date[9].hr = 0);
	(date[10].hr = 19);
	(date[11].hr = 14);
	(date[12].hr = 15);
	(date[13].hr = 18);
	(date[14].hr = 19);
	(date[15].hr = 20);
	(date[16].hr = 2);
	(date[17].hr = 12);
	(date[18].hr = 18);
	(date[19].hr = 20);
	(date[20].hr = 20);
	(date[21].hr = 5);
	(date[22].hr = 4);
	(date[23].hr = 5);
	(date[24].hr = 3);
	(date[25].hr = 20);

	(date[0].min = 44);
	(date[1].min = 24);
	(date[2].min = 50);
	(date[3].min = 47);
	(date[4].min = 6);
	(date[5].min = 4);
	(date[6].min = 38);
	(date[7].min = 29);
	(date[8].min = 57);
	(date[9].min = 41);
	(date[10].min = 19);
	(date[11].min = 54);
	(date[12].min = 15);
	(date[13].min = 58);
	(date[14].min = 59);
	(date[15].min = 0);
	(date[16].min = 6);
	(date[17].min = 34);
	(date[18].min = 13);
	(date[19].min = 43);
	(date[20].min = 5);
	(date[21].min = 52);
	(date[22].min = 10);
	(date[23].min = 30);
	(date[24].min = 4);
	(date[25].min = 30);

	(date[0].mon = 4);
	(date[1].mon = 5);
	(date[2].mon = 5);
	(date[3].mon = 6);
	(date[4].mon = 6);
	(date[5].mon = 7);
	(date[6].mon = 8);
	(date[7].mon = 9);
	(date[8].mon = 10);
	(date[9].mon = 11);
	(date[10].mon = 12);
	(date[11].mon = 12);
	(date[12].mon = 1);
	(date[13].mon = 2);
	(date[14].mon = 3);
	(date[15].mon = 3);
	(date[16].mon = 3);
	(date[17].mon = 3);
	(date[18].mon = 3);
	(date[19].mon = 3);
	(date[20].mon = 3);
	(date[21].mon = 3);
	(date[22].mon = 3);
	(date[23].mon = 3);
	(date[24].mon = 3);
	(date[25].mon = 3);

	(date[0].day = 4);
	(date[1].day = 24);
	(date[2].day = 15);
	(date[3].day = 17);
	(date[4].day = 6);
	(date[5].day = 24);
	(date[6].day = 30);
	(date[7].day = 29);
	(date[8].day = 7);
	(date[9].day = 11);
	(date[10].day = 19);
	(date[11].day = 5);
	(date[12].day = 19);
	(date[13].day = 28);
	(date[14].day = 29);
	(date[15].day = 30);
	(date[16].day = 30);
	(date[17].day = 30);
	(date[18].day = 30);
	(date[19].day = 30);
	(date[20].day = 30);
	(date[21].day = 30);
	(date[22].day = 30);
	(date[23].day = 30);
	(date[24].day = 30);
	(date[25].day = 30);

	(date[0].yr = 1904-2000);
	(date[1].yr = 1900-2000);
	(date[2].yr = 1999-2000);
	(date[3].yr = 1998-2000);
	(date[4].yr = 1997-2000);
	(date[5].yr = 1996-2000);
	(date[6].yr = 1995-2000);
	(date[7].yr = 1998-2000);
	(date[8].yr = 1988-2000);
	(date[9].yr = 1984-2000);
	(date[10].yr = 1980-2000);
	(date[11].yr = 2025-2000);
	(date[12].yr = 2049-2000);
	(date[13].yr = 2000-2000);
	(date[14].yr = 2099-2000);
	(date[15].yr = 2120-2000);
	(date[16].yr = 2120-2000);
	(date[17].yr = 2120-2000);
	(date[18].yr = 2120-2000);
	(date[19].yr = 2120-2000);
	(date[20].yr = 2120-2000);
	(date[21].yr = 2120-2000);
	(date[22].yr = 2120-2000);
	(date[23].yr = 2120-2000);
	(date[24].yr = 2120-2000);
	(date[25].yr = 2120-2000);

        strcpy(info[0],"WWWWWWWWWWWWWW");
        strcpy(info[1],"");
        strcpy(info[2],"");
        strcpy(info[3],"Parking");
        strcpy(info[4],"OK!");
        strcpy(info[5],"");
        strcpy(info[6],"OK!");
        strcpy(info[7],"");
        strcpy(info[8],"01234567890123456789");
        strcpy(info[9],"Merry X'Mas!");
        strcpy(info[10],"Happy New!");
        strcpy(info[11],"Last Holiday!");
        strcpy(info[12],"Merry X'Mas & Happy New!");
        strcpy(info[13],"Key");
        strcpy(info[14],"Snow Ball");
        strcpy(info[15],"Dragon!");
        strcpy(info[16],"Don!");
        strcpy(info[17],"gon!");
        strcpy(info[18],"Dra!");
        strcpy(info[19],"Dron!");
        strcpy(info[20],"ragon!");
        strcpy(info[21],"DD on!");
        strcpy(info[22],"KKL!");
        strcpy(info[23],"");
        strcpy(info[24],"tea!");
        strcpy(info[25],"fish");

	/* New Database */
	if (!DataFindDB((BYTE*)"VoxMemoDatabase", &VoxMemo_dbid))
		if (DataNewDB((BYTE*)"VoxMemoDatabase", 1, (BYTE*)("VoxMemo Application"), &VoxMemo_dbid) == ERR_DATA_NO_SPACE)
			return FALSE;
	if (DataOpenDB(VoxMemo_dbid, F_time_date, OPEN_RW) != TRUE)
		return FALSE;
	/* Open Database */
	for(i=0; i<k; i++)
	{
		if (DataNewRecord(VoxMemo_dbid, 1, 4, &VoxMemo_rec_id) != TRUE)
			return FALSE;
		if (DataWriteField(VoxMemo_dbid,VoxMemo_rec_id, F_time_date, 5, (BYTE*)&date[i]) != TRUE)
			return FALSE;
                if (DataWriteField(VoxMemo_dbid,VoxMemo_rec_id, F_info,(strlen(info[i])+1), info[i]) != TRUE)
			return FALSE;
		if (DataCloseRecord(VoxMemo_dbid, VoxMemo_rec_id) != TRUE)
			return FALSE;
        }


        DataDeleteRecord(VoxMemo_dbid, 3, TRUE);
        DataDeleteRecord(VoxMemo_dbid, 4, TRUE);

//        for(i=0; i<k; i++)
///                pfree(info[i]);

	return TRUE;
}

BOOLEAN SysSetupDatabaseInit(void)
{
	USHORT i = 0;
        char x[20];
        DatabaseID              dbid;
        RecordID                rec_id;

        if(DataFindDB((BYTE*) "SySetupDatabase", &pb_dbid) == TRUE)
                return;


        DataNewDB((BYTE*)("SySetupDatabase"),1,(BYTE*)("System Application"),&dbid);
        DataOpenDB(dbid,0,OPEN_RW);
        DataNewRecord(dbid,0x00,10,&rec_id);
        x[0] = 0x05;
        DataWriteField(dbid,rec_id,0,1,x);

        x[0] = 'C';
        x[1] = 'h';
        x[2] = 'a';
        x[3] = 'n';
        x[4] = 0x00;
        DataWriteField(dbid,rec_id,1,5, x);
        x[0] = 'A';
        x[1] = 'l';
        x[2] = 'i';
        x[3] = 'c';
        x[4] = 'e';
        x[5] = 0x00;
        DataWriteField(dbid,rec_id,2,6, x);

/*
        x[0] = 'N';
        x[1] = 'g';
        x[2] = 0x00;
        DataWriteField(dbid,rec_id,1,3, x);
        x[0] = 'K';
        x[1] = 'e';
        x[2] = 'n';
        x[3] = 'n';
        x[4] = 'y';
        x[5] = 0x00;
        DataWriteField(dbid,rec_id,2,6, x);
*/

        DataCloseRecord(dbid, rec_id);
        DataCloseDB(dbid);
}

void EmailDatabaseInit()
{
	RecordID rec_id;
	SHORT i = 0, j = 0;
        DatabaseID email_dbid;
		
	BYTE personal_cate[15];
	BYTE business_cate[10];

	BYTE *personal_first_name[15];
	BYTE *business_first_name[10];

	BYTE *personal_last_name[15];
	BYTE *business_last_name[10];

	BYTE *personal_name[15];
	BYTE *business_name[10];

	BYTE *personal_email[15];
	BYTE *business_email[10];

        if(DataFindDB((BYTE*) "Email Database", &pb_dbid) == TRUE)
                return;


	/* setting up dataaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa */
	for (i = 0; i <15; i++)
		personal_cate[i] = 4;
	for (i = 0; i <10; i++)
		business_cate[i] = 1;

	for (i = 0; i <15; i++)
	{
		personal_first_name[i] = (BYTE*)qmalloc(26*sizeof(BYTE));
		personal_last_name[i]  = (BYTE*)qmalloc(26*sizeof(BYTE));
		personal_name[i]       = (BYTE*)qmalloc(42*sizeof(BYTE));
		personal_email[i]	   = (BYTE*)qmalloc(60*sizeof(BYTE));
	}

	for (i = 0; i <10; i++)
	{
		business_first_name[i] = (BYTE*)qmalloc(26*sizeof(BYTE));
		business_last_name[i]  = (BYTE*)qmalloc(26*sizeof(BYTE));
		business_name[i]	   = (BYTE*)qmalloc(42*sizeof(BYTE));
		business_email[i]	   = (BYTE*)qmalloc(60*sizeof(BYTE));
	}


        strcpy(personal_first_name[0],"Kennth");
        strcpy(personal_first_name[1],"Rosita");
        strcpy(personal_first_name[2],"Patrick");
        strcpy(personal_first_name[3],"Fung Won");
        strcpy(personal_first_name[4],"Siu Lon");
        strcpy(personal_first_name[5],"Fax Modem");
        strcpy(personal_first_name[6],"Grace");
        strcpy(personal_first_name[7],"Mary");
        strcpy(personal_first_name[8],"Wendy");
        strcpy(personal_first_name[9],"Wendy1");
        strcpy(personal_first_name[10],"YY");
        strcpy(personal_first_name[11],"Why Why");
        strcpy(personal_first_name[12],"CaCa");
        strcpy(personal_first_name[13],"Alex");
        strcpy(personal_first_name[14],"Vz");


        strcpy(business_first_name[0],"Ester");
        strcpy(business_first_name[1],"Vivien");
        strcpy(business_first_name[2],"Damon");
        strcpy(business_first_name[3],"Eddie");
        strcpy(business_first_name[4],"Greg");
        strcpy(business_first_name[5],"Ray");
        strcpy(business_first_name[6],"Ken");
        strcpy(business_first_name[7],"Carry.");
        strcpy(business_first_name[8],"Nelson");
        strcpy(business_first_name[9],"Bonnie");


        strcpy(personal_last_name[0],"FOK");
        strcpy(personal_last_name[1],"Siu");
        strcpy(personal_last_name[2],"Ng");
        strcpy(personal_last_name[3],"Lo");
        strcpy(personal_last_name[4],"FOK");
        strcpy(personal_last_name[5],"Yuen");
        strcpy(personal_last_name[6],"Mak");
        strcpy(personal_last_name[7],"Wah");
        strcpy(personal_last_name[8],"Ng");
        strcpy(personal_last_name[9],"Yip");
        strcpy(personal_last_name[10],"Siu");
        strcpy(personal_last_name[11],"Chan");
        strcpy(personal_last_name[12],"Kwok");
        strcpy(personal_last_name[13],"Chow");
        strcpy(personal_last_name[14],"Lee");


        strcpy(business_last_name[0],"Cheng");
        strcpy(business_last_name[1],"Wong");
        strcpy(business_last_name[2],"Wang");
        strcpy(business_last_name[3],"Chan");
        strcpy(business_last_name[4],"Lee");
        strcpy(business_last_name[5],"Lee");
        strcpy(business_last_name[6],"Wong");
        strcpy(business_last_name[7],"Yiu");
        strcpy(business_last_name[8],"Chan");
        strcpy(business_last_name[9],"Lam");

        strcpy(personal_name[0],"Kennth FOK");
        strcpy(personal_name[1],"Rosita Siu");
        strcpy(personal_name[2],"Patrick Ng");
        strcpy(personal_name[3],"Fung Won Lo");
        strcpy(personal_name[4],"Siu Lon FOK");
        strcpy(personal_name[5],"Fax Modem Yuen");
        strcpy(personal_name[6],"Grace Mak");
        strcpy(personal_name[7],"Mary Wah");
        strcpy(personal_name[8],"Wendy Ng");
        strcpy(personal_name[9],"Wendy1 Yip");
        strcpy(personal_name[10],"YY Siu");
        strcpy(personal_name[11],"Why Why Chan");
        strcpy(personal_name[12],"CaCa Kwok");
        strcpy(personal_name[13],"Alex Chow");
        strcpy(personal_name[14],"Vz Lee");


        strcpy(business_name[0],"Ester Cheng");
        strcpy(business_name[1],"Vivien Wong");
        strcpy(business_name[2],"Damon Wang");
        strcpy(business_name[3],"Eddie Chan");
        strcpy(business_name[4],"Greg Lee");
        strcpy(business_name[5],"Ray Lee");
        strcpy(business_name[6],"Ken Wong");
        strcpy(business_name[7],"Carry. Yiu");
        strcpy(business_name[8],"Nelson Chan");
        strcpy(business_name[9],"Bonnie Lam");

        strcpy(personal_email[0],"henry_fok@vtech.com.hk");
        strcpy(personal_email[1],"rosita_siu@vtech.com.hk");
        strcpy(personal_email[2],"patrick_ng@vtech.com.hk");
        strcpy(personal_email[3],"fung_won_lo@vtech.com.hk");
        strcpy(personal_email[4],"siu_lon_fok@vtech.com.hk");
        strcpy(personal_email[5],"fax_modem_yuen@vtech.com.hk");
        strcpy(personal_email[6],"grace_mak@vtech.com.hk");
        strcpy(personal_email[7],"mary_wah@vtech.com.hk");
        strcpy(personal_email[8],"wendy_ng@vtech.com.hk");
        strcpy(personal_email[9],"wendy1_yip@vtech.com.hk");
        strcpy(personal_email[10],"yy_siu@vtech.com.hk");
        strcpy(personal_email[11],"why_why_chan@vtech.com.hk");
        strcpy(personal_email[12],"caca_kwok@vtech.com.hk");
        strcpy(personal_email[13],"alex_chow@vtech.com.hk");
        strcpy(personal_email[14],"vz_lee@vtech.com.hk");

        strcpy(business_email[0],"ester_cheng@vtech.com.hk");
        strcpy(business_email[1],"vivien_wong@vtech.com.hk");
        strcpy(business_email[2],"damon_wang@vtech.com.hk");
        strcpy(business_email[3],"eddie_chan@vtech.com.hk");
        strcpy(business_email[4],"greg_lee@vtech.com.hk");
        strcpy(business_email[5],"ray_lee@vtech.com.hk");
        strcpy(business_email[6],"ken_wong@vtech.com.hk");
        strcpy(business_email[7],"carry._yiu@vtech.com.hk");
        strcpy(business_email[8],"nelson_chan@vtech.com.hk");
        strcpy(business_email[9],"bonnie_lam@vtech.com.hk");
	
	/* New Database */
	DataNewDB((BYTE*)("Email Database"),1,(BYTE*)("Email Application"),&email_dbid);
	DataOpenDB(email_dbid,2,OPEN_RW);

	/* Open Database */
						
	DataCategorySetName(email_dbid,0,(BYTE*)("Unfiled"));
	DataCategorySetName(email_dbid,1,(BYTE*)("Business"));
	DataCategorySetName(email_dbid,2,(BYTE*)("Engineering"));
	DataCategorySetName(email_dbid,3,(BYTE*)("Office"));	
	DataCategorySetName(email_dbid,4,(BYTE*)("Personal"));

	for (i = 0;i<15;i++)
	{
		DataNewRecord(email_dbid,personal_cate[i],4,&rec_id);
                DataWriteField(email_dbid,rec_id,0,(strlen(personal_first_name[i]) + 1),personal_first_name[i]);
                DataWriteField(email_dbid,rec_id,1,(strlen(personal_last_name[i]) + 1),personal_last_name[i]);
                DataWriteField(email_dbid,rec_id,2,(strlen(personal_name[i]) + 1),personal_name[i]);
                DataWriteField(email_dbid,rec_id,3,(strlen(personal_email[i]) + 1),personal_email[i]);
		DataCloseRecord(email_dbid,rec_id);
	}	
	for (i = 0;i<10;i++)
	{
		DataNewRecord(email_dbid,business_cate[i],4,&rec_id);
                DataWriteField(email_dbid,rec_id,0,(strlen(business_first_name[i]) + 1),business_first_name[i]);
                DataWriteField(email_dbid,rec_id,1,(strlen(business_last_name[i]) + 1),business_last_name[i]);
                DataWriteField(email_dbid,rec_id,2,(strlen(business_name[i]) + 1),business_name[i]);
                DataWriteField(email_dbid,rec_id,3,(strlen(business_email[i]) + 1),business_email[i]);
		DataCloseRecord(email_dbid,rec_id);
	}

        DataDeleteRecord(email_dbid, 3, TRUE);
        DataDeleteRecord(email_dbid, 4, TRUE);

        DataCloseDB(email_dbid);
/*	for (i = 0; i <15; i++)
	{
		qfree(personal_first_name[i]);
		qfree(personal_last_name[i]);
		qfree(personal_name[i]);
		qfree(personal_email[i]);
	}
	for (i = 0; i <10; i++)
	{
		qfree(business_first_name[i]);
		qfree(business_last_name[i]);
		qfree(business_name[i]);
		qfree(business_email[i]);
	}
*/
}


BOOLEAN EmailSearchForText(BYTE *short_string, BYTE *whole_string)
{
	UWORD length_short;
	UWORD length_whole;
	BYTE  *buffer, *buffer1, *buffer2;
	UWORD count, letter_count;
	BOOLEAN match = TRUE;



        length_short = strlen(short_string);
        length_whole = strlen(whole_string);
	buffer2 = whole_string;

	for (count = 0; count <= length_whole; count++)
	{
		match = TRUE;
		buffer1 = buffer2;
		buffer = short_string;
                if (strlen(buffer1) < length_short)
			return FALSE;

		if (*buffer == *buffer1)
		{	
			buffer++;
			buffer1++;
			buffer2 = buffer1;
			for (letter_count = 0; letter_count<(length_short - 1); letter_count++)
			{
				if (*buffer != *buffer1)
				{	
					match = FALSE;
					break;
				}
				buffer++;
				buffer1++;
			}
		}
		else
		{
			match = FALSE;
			buffer2++;
		}
		if (match == TRUE)
			return TRUE;
	}
	return FALSE;
}



BYTE* EmailConvertDate(BYTE *input_date)
{
	BYTE *sbuffer;
	BYTE count = 0;
	BYTE num_char = 0;
	BYTE *month;
	BYTE *hour;
	BYTE *temp, *temp1, *temp2;
	BYTE *day;
	BYTE last_found = 0;
	BYTE *year;


        sbuffer = (BYTE*)qmalloc((strlen(input_date) + 3)*sizeof(BYTE));
        month   = (BYTE*)qmalloc((strlen(input_date) + 3)*sizeof(BYTE));
        day             = (BYTE*)qmalloc((strlen(input_date) + 3)*sizeof(BYTE));
        hour    = (BYTE*)qmalloc((strlen(input_date) + 3)*sizeof(BYTE));
        year    = (BYTE*)qmalloc((strlen(input_date) + 3)*sizeof(BYTE));

        if (EmailSearchForText((BYTE*)("Jan"), input_date) == TRUE) strcpy(month, (BYTE*)("01")); 
        else if (EmailSearchForText((BYTE*)("Feb"), input_date) == TRUE) strcpy(month, (BYTE*)("02")); 
        else if (EmailSearchForText((BYTE*)("Mar"), input_date) == TRUE) strcpy(month, (BYTE*)("03")); 
        else if (EmailSearchForText((BYTE*)("Apr"), input_date) == TRUE) strcpy(month, (BYTE*)("04")); 
        else if (EmailSearchForText((BYTE*)("May"), input_date) == TRUE) strcpy(month, (BYTE*)("05")); 
        else if (EmailSearchForText((BYTE*)("Jun"), input_date) == TRUE) strcpy(month, (BYTE*)("06")); 
        else if (EmailSearchForText((BYTE*)("Jul"), input_date) == TRUE) strcpy(month, (BYTE*)("07")); 
        else if (EmailSearchForText((BYTE*)("Aug"), input_date) == TRUE) strcpy(month, (BYTE*)("08")); 
        else if (EmailSearchForText((BYTE*)("Sep"), input_date) == TRUE) strcpy(month, (BYTE*)("09")); 
        else if (EmailSearchForText((BYTE*)("Oct"), input_date) == TRUE) strcpy(month, (BYTE*)("10")); 
        else if (EmailSearchForText((BYTE*)("Nov"), input_date) == TRUE) strcpy(month, (BYTE*)("11")); 
        else if (EmailSearchForText((BYTE*)("Dec"), input_date) == TRUE) strcpy(month, (BYTE*)("12"));


	/* search for hour */
	temp = input_date;
	temp1 = hour;
        for (count = 0; count < strlen(input_date); count++)
	{
		if (*temp == ':')
			break;
		else temp ++;
	}

	temp = input_date + count - 2;
	for (count = 0; count <= 2; count++)
	{
                strcpy(hour,temp);
		hour += 2;
		temp += 3;
	}


	hour = temp1;

	/* search for year and day*/
	temp = input_date;
	temp1 = day;
	temp2 = year;
        for (count = 0; count < strlen(input_date); count++)
	{
		if (*temp == 'J' || *temp == 'A' || *temp == 'N' || *temp == 'D' || *temp == 'O')
		{
			temp -= 3;
                        strcpy(day, temp);
			day += 2;
			*day = '\0';
			temp += 7;
			if (*temp < '9' && *(temp + 1) == '0')
			{
                                strcpy(year, "20");
				year += 2;
                                strcpy(year, temp);
				*(year + 2) = '\0';
			}
			else
			{
                                strcpy(year, "19");
				year += 2;
                                strcpy(year, temp);
				*(year + 2) = '\0';
			}
		}
		else if (*temp == 'M' || *temp == 'S' || *temp == 'F')
		{
			last_found = *temp;
			temp  ++;
			continue;
		}
		else if ((last_found == 'M' || last_found == 'S' || last_found == 'F'))
		{
			if (*temp == 'e' || *temp == 'a')
			{
				temp -= 4;
                                strcpy(day, temp);
				day += 2;
				*day = '\0';
				temp += 7;
				if (*temp < '9')
				{
                                        strcpy(year, "20");
					year += 2;
                                        strcpy(year, temp);
					*(year + 2) = '\0';
				}
				else
				{
                                        strcpy(year, "19");
					year += 2;
                                        strcpy(year, temp);
					*(year + 2) = '\0';
				}
			}
			else
			{
				last_found = 0;
				temp++;
				continue;
			}
		}
		else temp++;
	}

	day = temp1;
	year = temp2;

	temp = sbuffer;
        strcpy(sbuffer, year);
	sbuffer += 4;
        strcpy(sbuffer, month);
	sbuffer += 2;
        strcpy(sbuffer, day);
	sbuffer += 2;
        strcpy(sbuffer, hour);


	qfree(day);
	qfree(month);

	qfree(hour);
	qfree(year);

	return temp;
}



void EmailMessageDatabaseInit()
{
        DatabaseID emess_dbid;
	RecordID rec_id;
	SHORT j = 0;
	UWORD i;

#define TIME_INDEX_RECID  0x80001000

	UWORD time_index;

	BYTE *inbox_to[13];
	BYTE *outbox_to[5];
	BYTE *sent_to[5];
	BYTE *draft_to[5];

	BYTE *inbox_date[13];
	BYTE *outbox_date[5];
	BYTE *sent_date[5];
	BYTE *draft_date[5];
	
	BYTE *inbox_from[13];
	BYTE *outbox_from[5];
	BYTE *sent_from[5];
	BYTE *draft_from[5];

	BYTE *inbox_cc[13];
	BYTE *outbox_cc[5];
	BYTE *sent_cc[5];
	BYTE *draft_cc[5];

	BYTE *inbox_bcc[13];
	BYTE *outbox_bcc[5];
	BYTE *sent_bcc[5];
	BYTE *draft_bcc[5];

	BYTE *inbox_subject[13];
	BYTE *outbox_subject[5];
	BYTE *sent_subject[5];
	BYTE *draft_subject[5];

	BYTE *inbox_body[13];
	BYTE *outbox_body[5];
	BYTE *sent_body[5];
	BYTE *draft_body[5];

        if(DataFindDB((BYTE*) "Email Message Database", &pb_dbid) == TRUE)
                return;


	for (i = 0; i <13; i++)
	{
                inbox_date[i]   = (BYTE*)qmalloc(35*sizeof(BYTE));
		inbox_from[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		inbox_to[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		inbox_cc[i]     = (BYTE*)qmalloc(200*sizeof(BYTE));
		inbox_bcc[i]    = (BYTE*)qmalloc(200*sizeof(BYTE));
		inbox_subject[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		inbox_body[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));

	}

	for (i = 0; i <5; i++)
	{
                outbox_date[i]  = (BYTE*)qmalloc(35*sizeof(BYTE));
		outbox_to[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		outbox_from[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		outbox_cc[i]     = (BYTE*)qmalloc(200*sizeof(BYTE));
		outbox_bcc[i]    = (BYTE*)qmalloc(200*sizeof(BYTE));
		outbox_subject[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		outbox_body[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
	}

	for (i = 0; i <5; i++)
	{
                sent_date[i]    = (BYTE*)qmalloc(35*sizeof(BYTE));
		sent_to[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		sent_from[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		sent_cc[i]     = (BYTE*)qmalloc(200*sizeof(BYTE));
		sent_bcc[i]    = (BYTE*)qmalloc(200*sizeof(BYTE));
		sent_subject[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		sent_body[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
	}

	for (i = 0; i <5; i++)
	{
		draft_date[i]	= (BYTE*)qmalloc(25*sizeof(BYTE));
		draft_to[i]		= (BYTE*)qmalloc(200*sizeof(BYTE));
		draft_from[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		draft_cc[i]     = (BYTE*)qmalloc(200*sizeof(BYTE));
		draft_bcc[i]    = (BYTE*)qmalloc(200*sizeof(BYTE));
		draft_subject[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
		draft_body[i]	= (BYTE*)qmalloc(200*sizeof(BYTE));
	}

        strcpy(inbox_date[0],EmailConvertDate((BYTE*)("Fri 09 Jun 12 11:12:27")));
        strcpy(inbox_from[0],(BYTE*)("  aWendy Siu  <wendy_siu@vtech.com.hk>"));
        strcpy(inbox_to[0], (BYTE*)("<henry_fok@vtech.com.hk>"));
        strcpy(inbox_cc[0],(BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_bcc[0],(BYTE*)(""));
        strcpy(inbox_subject[0],(BYTE*)("Inbox Test 1"));
        strcpy(inbox_body[0],(BYTE*)("HiHi\rInbox Message 1\r\rHenry Fok"));

        strcpy(inbox_date[1],EmailConvertDate((BYTE*)("Fri 09 Jun 00 11:12:27")));
        strcpy(inbox_from[1],(BYTE*)("Wendy Siu<wendy_siu@vtech.com.hk>"));
        strcpy(inbox_to[1], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[1],(BYTE*)(""));
        strcpy(inbox_bcc[1],(BYTE*)(""));
        strcpy(inbox_subject[1],(BYTE*)("Inbox Test 2"));
        strcpy(inbox_body[1],(BYTE*)("HiHi\rInbox Message 2\r\rWendy Siu"));


        strcpy(inbox_date[2],EmailConvertDate((BYTE*)("Fri 11 Jun 98 11:12:27")));
        strcpy(inbox_from[2],(BYTE*)("KK<k_k@vtech.com.hk>"));
        strcpy(inbox_to[2], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[2],(BYTE*)(""));
        strcpy(inbox_bcc[2],(BYTE*)(""));
        strcpy(inbox_subject[2],(BYTE*)("Inbox Test 3"));
        strcpy(inbox_body[2],(BYTE*)("HiHi\rInbox Message 3\r\rK.K."));

        strcpy(inbox_date[3],EmailConvertDate((BYTE*)("Fri 07 Jun 98 11:12:27")));
        strcpy(inbox_from[3],(BYTE*)("yogi_yogi@vtech.com.hk"));
        strcpy(inbox_to[3], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[3],(BYTE*)(""));
        strcpy(inbox_bcc[3],(BYTE*)(""));
        strcpy(inbox_subject[3],(BYTE*)("Inbox Test 4"));
        strcpy(inbox_body[3],(BYTE*)("HiHi\rInbox Message 4\r\rHenry Fok"));

        strcpy(inbox_date[4],EmailConvertDate((BYTE*)("Fri 09 May 98 11:12:27")));
        strcpy(inbox_from[4],(BYTE*)("ca_ca@vtech.com.hk"));
        strcpy(inbox_to[4], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[4],(BYTE*)(""));
        strcpy(inbox_bcc[4],(BYTE*)(""));
        strcpy(inbox_subject[4],(BYTE*)(""));
        strcpy(inbox_body[4],(BYTE*)("HiHi\rInbox Message 5\r\rHenry Fok"));

        strcpy(inbox_date[5],EmailConvertDate((BYTE*)("Fri 09 May 97 11:12:27")));
        strcpy(inbox_from[5],(BYTE*)("Wen Wen  <wen_wen@vtech.com.hk>"));
        strcpy(inbox_to[5], (BYTE*)("Henry Fok<henry_fok@vtech.com.hk>"));
        strcpy(inbox_cc[5],(BYTE*)(""));
        strcpy(inbox_bcc[5],(BYTE*)(""));
        strcpy(inbox_subject[5],(BYTE*)(""));
        strcpy(inbox_body[5],(BYTE*)("HiHi\rInbox Message 6\r\rThis is a testing message in order to test the viewing mode, \ra\rb\rc\rd\rHappy\rHenry Fok"));

//      strcpy(inbox_name[6],(BYTE*)(""));
        strcpy(inbox_date[6],EmailConvertDate((BYTE*)("Fri 09 May 95 11:12:27")));
        strcpy(inbox_from[6],(BYTE*)("hewfok@vtech.com.hk"));
        strcpy(inbox_to[6], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[6],(BYTE*)(""));
        strcpy(inbox_bcc[6],(BYTE*)(""));
        strcpy(inbox_subject[6],(BYTE*)(""));
        strcpy(inbox_body[6],(BYTE*)("HiHi\rInbox Message 7\r\rHenry Fok"));

//      strcpy(inbox_name[7],(BYTE*)("CaCa"));
        strcpy(inbox_date[7],EmailConvertDate((BYTE*)("Fri 09 May 98 11:12:27")));
        strcpy(inbox_from[7],(BYTE*)("Ca Ca <ca_ca@vtech.com.hk>"));
        strcpy(inbox_to[7], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[7],(BYTE*)(""));
        strcpy(inbox_bcc[7],(BYTE*)(""));
        strcpy(inbox_subject[7],(BYTE*)(""));
        strcpy(inbox_body[7],(BYTE*)("HiHi\rInbox Message 8\r\rHenry Fok"));

//      strcpy(inbox_name[8],(BYTE*)(""));
        strcpy(inbox_date[8],EmailConvertDate((BYTE*)("Fri 09 May 92 11:12:27")));
        strcpy(inbox_from[8],(BYTE*)("Aoi Aoi<aoi_aoi@vtech.com.hk>\r  henry_fok@vtech.com.hk \r <kenny_ng@vtech.com.hk>"));
        strcpy(inbox_to[8], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[8],(BYTE*)(""));
        strcpy(inbox_bcc[8],(BYTE*)(""));
        strcpy(inbox_subject[8],(BYTE*)("123"));
        strcpy(inbox_body[8],(BYTE*)("HiHi\rInbox Message 9\r\rHenry Fok"));
	
//      strcpy(inbox_name[9],(BYTE*)("To To"));
        strcpy(inbox_date[9],EmailConvertDate((BYTE*)("Fri 09 May 01 11:12:27")));
        strcpy(inbox_from[9],(BYTE*)("To To<to_to@vtech.com.hk>"));
        strcpy(inbox_to[9], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[9],(BYTE*)(""));
        strcpy(inbox_bcc[9],(BYTE*)(""));
        strcpy(inbox_subject[9],(BYTE*)(""));
        strcpy(inbox_body[9],(BYTE*)("HiHi\rInbox Message 10\r\rHenry Fok"));

//      strcpy(inbox_name[10],(BYTE*)("Ajai"));
        strcpy(inbox_date[10],EmailConvertDate((BYTE*)("Fri 09 May 01 11:12:27")));
        strcpy(inbox_from[10],(BYTE*)("ajai@vtech.com.hk"));
        strcpy(inbox_to[10], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[10],(BYTE*)(""));
        strcpy(inbox_bcc[10],(BYTE*)(""));
        strcpy(inbox_subject[10],(BYTE*)(""));
        strcpy(inbox_body[10],(BYTE*)("HiHi\rInbox Message 11\r\rHenry Fok"));

//      strcpy(inbox_name[11],(BYTE*)("BJai"));
        strcpy(inbox_date[11],EmailConvertDate((BYTE*)("Fri 09 May 01 11:12:27")));
        strcpy(inbox_from[11],(BYTE*)("BJai<bjai@vtech.com.hk>"));
        strcpy(inbox_to[11], (BYTE*)("henry_fok@vtech.com.hk"));
        strcpy(inbox_cc[11],(BYTE*)(""));
        strcpy(inbox_bcc[11],(BYTE*)(""));
        strcpy(inbox_subject[11],(BYTE*)(""));
        strcpy(inbox_body[11],(BYTE*)("HiHi\rInbox Message 12\r\rHenry Fok"));
	
//      strcpy(inbox_name[12],(BYTE*)("Cjai"));
        strcpy(inbox_date[12],EmailConvertDate((BYTE*)("Fri 09 May 01 11:12:27")));
        strcpy(inbox_from[12],(BYTE*)("CJai<cjai@vtech.com.hk>"));
        strcpy(inbox_to[12], (BYTE*)("henry_fok@vtech.com.hk\rWendy Siu <wendy_siu@vtech.com.hk>"));
        strcpy(inbox_cc[12],(BYTE*)("Kenny Ng  <kenny_ng@vtech.com.hk>"));
        strcpy(inbox_bcc[12],(BYTE*)(""));
        strcpy(inbox_subject[12],(BYTE*)("Lunch"));
        strcpy(inbox_body[12],(BYTE*)("HiHi\rInbox Message 13\r\rHenry Fok"));

//      strcpy(outbox_name[0],(BYTE*)("Co Co"));
        strcpy(outbox_date[0],(BYTE*)(""));
        strcpy(outbox_from[0],(BYTE*)(""));
        strcpy(outbox_to[0], (BYTE*)("Kenny Ng"));
        strcpy(outbox_cc[0],(BYTE*)(""));
        strcpy(outbox_bcc[0],(BYTE*)(""));
        strcpy(outbox_subject[0],(BYTE*)("outbox Test 1"));
        strcpy(outbox_body[0],(BYTE*)("HiHi\rOutbox Message 1\r\rHenry Fok"));

//      strcpy(outbox_name[1],(BYTE*)(""));
        strcpy(outbox_date[1],(BYTE*)(""));
        strcpy(outbox_to[1],(BYTE*)("wendy_siu@vtech.com.hk"));
        strcpy(outbox_from[1],(BYTE*)(""));
        strcpy(outbox_cc[1],(BYTE*)(""));
        strcpy(outbox_bcc[1],(BYTE*)(""));
        strcpy(outbox_subject[1],(BYTE*)("Outbox Test 2"));
        strcpy(outbox_body[1],(BYTE*)("HiHi\rOutbox Message 2\r\rHenry Fok"));

//      strcpy(outbox_name[2],(BYTE*)("Yes No"));
        strcpy(outbox_date[2],(BYTE*)(""));
        strcpy(outbox_to[2],(BYTE*)("Yes No"));
        strcpy(outbox_from[2],(BYTE*)(""));
        strcpy(outbox_cc[2],(BYTE*)(""));
        strcpy(outbox_bcc[2],(BYTE*)(""));
        strcpy(outbox_subject[2],(BYTE*)("Outbox Test 3"));
        strcpy(outbox_body[2],(BYTE*)("HiHi\rOutbox Message 3\r\rHenry Fok"));

//      strcpy(outbox_name[3],(BYTE*)(""));
        strcpy(outbox_date[3],(BYTE*)(""));
        strcpy(outbox_to[3],(BYTE*)("yogi_yogi@vtech.com.hk"));
        strcpy(outbox_from[3],(BYTE*)(""));
        strcpy(outbox_cc[3],(BYTE*)(""));
        strcpy(outbox_bcc[3],(BYTE*)(""));
        strcpy(outbox_subject[3],(BYTE*)("Outbox Test 4"));
        strcpy(outbox_body[3],(BYTE*)("HiHi\routbox Message 4\r\rHenry Fok"));

//      strcpy(outbox_name[4],(BYTE*)("Yip Yip"));
        strcpy(outbox_date[4],(BYTE*)(""));
        strcpy(outbox_to[4],(BYTE*)("yip_yip@vtech.com.hk"));
        strcpy(outbox_from[4],(BYTE*)(""));
        strcpy(outbox_cc[4],(BYTE*)(""));
        strcpy(outbox_bcc[4],(BYTE*)(""));
        strcpy(outbox_subject[4],(BYTE*)("Outbox Test 5"));
        strcpy(outbox_body[4],(BYTE*)("HiHi\routbox Message 5\r\rHenry Fok"));

//      strcpy(sent_name[0],(BYTE*)("Ta Ta"));
        strcpy(sent_date[0],(BYTE*)(""));
        strcpy(sent_to[0],(BYTE*)("Ta Ta"));
        strcpy(sent_from[0],(BYTE*)(""));
        strcpy(sent_cc[0],(BYTE*)(""));
        strcpy(sent_bcc[0],(BYTE*)(""));
        strcpy(sent_subject[0],(BYTE*)("sent Test 1"));
        strcpy(sent_body[0],(BYTE*)("HiHi\rsent Message 1\r\rHenry Fok"));

//      strcpy(sent_name[1],(BYTE*)(""));
        strcpy(sent_date[1],(BYTE*)(""));
        strcpy(sent_to[1],(BYTE*)("ba_ba@vtech.com.hk\rtata@vtech.com.hk"));
        strcpy(sent_from[1],(BYTE*)(""));
        strcpy(sent_cc[1],(BYTE*)(""));
        strcpy(sent_bcc[1],(BYTE*)(""));
        strcpy(sent_subject[1],(BYTE*)("sent Test 2"));
        strcpy(sent_body[1],(BYTE*)("HiHi\rsent Message 2\r\rHenry Fok"));

//      strcpy(sent_name[2],(BYTE*)("KA KA"));
        strcpy(sent_date[2],(BYTE*)(""));
        strcpy(sent_to[2],(BYTE*)("ka_ka@vtech.com.hk"));
        strcpy(sent_from[2],(BYTE*)(""));
        strcpy(sent_cc[2],(BYTE*)(""));
        strcpy(sent_bcc[2],(BYTE*)(""));
        strcpy(sent_subject[2],(BYTE*)("sent Test 3"));
        strcpy(sent_body[2],(BYTE*)("HiHi\rsent Message 3\r\rHenry Fok"));

//      strcpy(sent_name[3],(BYTE*)("AA"));
        strcpy(sent_date[3],(BYTE*)(""));
        strcpy(sent_to[3],(BYTE*)("AA"));
        strcpy(sent_from[3],(BYTE*)(""));
        strcpy(sent_cc[3],(BYTE*)(""));
        strcpy(sent_bcc[3],(BYTE*)(""));
        strcpy(sent_subject[3],(BYTE*)("sent Test 4"));
        strcpy(sent_body[3],(BYTE*)("HiHi\rsent Message 4\r\rHenry Fok"));

//      strcpy(sent_name[4],(BYTE*)("bebe"));
        strcpy(sent_date[4],(BYTE*)(""));
        strcpy(sent_to[4],(BYTE*)("bebe@vtech.com.hk"));
        strcpy(sent_from[4],(BYTE*)(""));
        strcpy(sent_cc[4],(BYTE*)(""));
        strcpy(sent_bcc[4],(BYTE*)(""));
        strcpy(sent_subject[4],(BYTE*)("sent Test 5"));
        strcpy(sent_body[4],(BYTE*)("HiHi\rsent Message 5\r\rHenry Fok"));

//      strcpy(draft_name[0],(BYTE*)("Wa Wa"));
        strcpy(draft_date[0],(BYTE*)(""));
        strcpy(draft_to[0],(BYTE*)("Wa Wa"));
        strcpy(draft_from[0],(BYTE*)(""));
        strcpy(draft_cc[0],(BYTE*)(""));
        strcpy(draft_bcc[0],(BYTE*)(""));
        strcpy(draft_subject[0],(BYTE*)("draft Test 1"));
        strcpy(draft_body[0],(BYTE*)("HiHi\rdraft Message 1\r\rHenry Fok"));

//      strcpy(draft_name[1],(BYTE*)(""));
        strcpy(draft_date[1],(BYTE*)(""));
        strcpy(draft_to[1],(BYTE*)("pa_pa@vtech.com.hk"));
        strcpy(draft_from[1],(BYTE*)(""));
        strcpy(draft_cc[1],(BYTE*)(""));
        strcpy(draft_bcc[1],(BYTE*)(""));
        strcpy(draft_subject[1],(BYTE*)("draft Test 2"));
        strcpy(draft_body[1],(BYTE*)("HiHi\rdraft Message 2\r\rHenry Fok"));

//      strcpy(draft_name[2],(BYTE*)("oUo"));
        strcpy(draft_date[2],(BYTE*)(""));
        strcpy(draft_to[2],(BYTE*)("oUo@vtech.com.hk"));
        strcpy(draft_from[2],(BYTE*)(""));
        strcpy(draft_cc[2],(BYTE*)(""));
        strcpy(draft_bcc[2],(BYTE*)(""));
        strcpy(draft_subject[2],(BYTE*)("draft Test 3"));
        strcpy(draft_body[2],(BYTE*)("HiHi\rdraft Message 3\r\rHenry Fok"));

//      strcpy(draft_name[3],(BYTE*)("gggg"));
        strcpy(draft_date[3],(BYTE*)(""));
        strcpy(draft_to[3],(BYTE*)("GGGG"));
        strcpy(draft_from[3],(BYTE*)(""));
        strcpy(draft_cc[3],(BYTE*)(""));
        strcpy(draft_bcc[3],(BYTE*)(""));
        strcpy(draft_subject[3],(BYTE*)("draft Test 4"));
        strcpy(draft_body[3],(BYTE*)("HiHi\rdraft Message 4\r\rHenry Fok"));

//      strcpy(draft_name[4],(BYTE*)("VTECH"));
        strcpy(draft_date[4],(BYTE*)(""));
        strcpy(draft_to[4],(BYTE*)("vtech@vtech.com.hk"));
        strcpy(draft_from[4],(BYTE*)(""));
        strcpy(draft_cc[4],(BYTE*)(""));
        strcpy(draft_bcc[4],(BYTE*)(""));
        strcpy(draft_subject[4],(BYTE*)("draft Test 5"));
        strcpy(draft_body[4],(BYTE*)("HiHi\rdraft Message 5\r\rHenry Fok"));

	/* New Database */
	DataNewDB((BYTE*)("Email Message Database"),0,(BYTE*)("Email Application"),&emess_dbid);
	DataOpenDB(emess_dbid,1,OPEN_RW);

	/* Open Database */
	DataCategorySetName(emess_dbid,0,(BYTE*)(""));
	DataCategorySetName(emess_dbid,1,(BYTE*)("Inbox"));
	DataCategorySetName(emess_dbid,2,(BYTE*)("Outbox"));
	DataCategorySetName(emess_dbid,3,(BYTE*)("Sent"));
	DataCategorySetName(emess_dbid,4,(BYTE*)("Draft"));	

	DataNewRecordWithID(emess_dbid, 0x80000101, 0, 4);


	/* inbox time index */
	time_index = 13;
        time_index = EL32(time_index);
	DataWriteField(emess_dbid, 0x80000101, 0, 4, (BYTE*) &time_index);
	/* outbox time index */
	time_index = 5;
        time_index = EL32(time_index);
	DataWriteField(emess_dbid, 0x80000101, 1, 4, (BYTE*) &time_index);
	/* sent time index */
	time_index = 5;
        time_index = EL32(time_index);
	DataWriteField(emess_dbid, 0x80000101, 2, 4, (BYTE*) &time_index);
	/* draft time index */
	time_index = 5;
        time_index = EL32(time_index);
	DataWriteField(emess_dbid, 0x80000101, 3, 4, (BYTE*) &time_index);

	for (i = 0;i<13;i++)
	{
		DataNewRecord(emess_dbid, 1, 8, &rec_id);
                DataWriteField(emess_dbid,rec_id,0,(strlen(inbox_date[i]) + 1),inbox_date[i]);
		DataWriteField(emess_dbid,rec_id,1,1, (BYTE*)(""));
                DataWriteField(emess_dbid,rec_id,2,(strlen(inbox_from[i]) + 1),inbox_from[i]);
                DataWriteField(emess_dbid,rec_id,3,(strlen(inbox_to[i]) + 1),inbox_to[i]);
                DataWriteField(emess_dbid,rec_id,4,(strlen(inbox_cc[i]) + 1),inbox_cc[i]);
                DataWriteField(emess_dbid,rec_id,5,(strlen(inbox_bcc[i]) + 1),inbox_bcc[i]);
                DataWriteField(emess_dbid,rec_id,6,(strlen(inbox_subject[i]) + 1),inbox_subject[i]);
                DataWriteField(emess_dbid,rec_id,7,(strlen(inbox_body[i]) + 1),inbox_body[i]);
		DataCloseRecord(emess_dbid,rec_id);
	}

	for (i = 0;i<5;i++)
	{
		DataNewRecord(emess_dbid, 4, 8, &rec_id);
                DataWriteField(emess_dbid,rec_id,0,(strlen(draft_date[i]) + 1),draft_date[i]);
		time_index = i;
                time_index = EL32(time_index);
                DataWriteField(emess_dbid,rec_id,1, 4, (BYTE*)&time_index);
                DataWriteField(emess_dbid,rec_id,2,(strlen(draft_from[i]) + 1),draft_from[i]);
                DataWriteField(emess_dbid,rec_id,3,(strlen(draft_to[i]) + 1),draft_to[i]);
                DataWriteField(emess_dbid,rec_id,4,(strlen(draft_cc[i]) + 1),draft_cc[i]);
                DataWriteField(emess_dbid,rec_id,5,(strlen(draft_bcc[i]) + 1),draft_bcc[i]);
                DataWriteField(emess_dbid,rec_id,6,(strlen(draft_subject[i]) + 1),draft_subject[i]);
                DataWriteField(emess_dbid,rec_id,7,(strlen(draft_body[i]) + 1),draft_body[i]);
		DataCloseRecord(emess_dbid,rec_id);
	}

	for (i = 0;i<5;i++)
	{
		DataNewRecord(emess_dbid, 2, 8, &rec_id);
                DataWriteField(emess_dbid,rec_id,0,(strlen(outbox_date[i]) + 1),outbox_date[i]);
		//temp = EmailTimeIndexToString(i);
                //DataWriteField(emess_dbid,rec_id,1,strlen(temp) + 1,temp);
		time_index = i;
                time_index = EL32(time_index);
		DataWriteField(emess_dbid,TIME_INDEX_RECID,1, 4, (BYTE*)&time_index);
                DataWriteField(emess_dbid,rec_id,2,(strlen(outbox_from[i]) + 1),outbox_from[i]);
                DataWriteField(emess_dbid,rec_id,3,(strlen(outbox_to[i]) + 1),outbox_to[i]);
                DataWriteField(emess_dbid,rec_id,4,(strlen(outbox_cc[i]) + 1),outbox_cc[i]);
                DataWriteField(emess_dbid,rec_id,5,(strlen(outbox_bcc[i]) + 1),outbox_bcc[i]);
                DataWriteField(emess_dbid,rec_id,6,(strlen(outbox_subject[i]) + 1),outbox_subject[i]);
                DataWriteField(emess_dbid,rec_id,7,(strlen(outbox_body[i]) + 1),outbox_body[i]);
		DataCloseRecord(emess_dbid,rec_id);
	}


	for (i = 0;i<5;i++)
	{
		DataNewRecord(emess_dbid, 3, 8, &rec_id);
                DataWriteField(emess_dbid,rec_id,0,(strlen(sent_date[i]) + 1),sent_date[i]);
		//temp = EmailTimeIndexToString(i);
                //DataWriteField(emess_dbid,rec_id,1,strlen(temp) + 1,temp);
		time_index = i;
                time_index = EL32(time_index);
		DataWriteField(emess_dbid,TIME_INDEX_RECID,2, 4, (BYTE*)&time_index);
                DataWriteField(emess_dbid,rec_id,2,(strlen(sent_from[i]) + 1),sent_from[i]);
                DataWriteField(emess_dbid,rec_id,3,(strlen(sent_to[i]) + 1),sent_to[i]);
                DataWriteField(emess_dbid,rec_id,4,(strlen(sent_cc[i]) + 1),sent_cc[i]);
                DataWriteField(emess_dbid,rec_id,5,(strlen(sent_bcc[i]) + 1),sent_bcc[i]);
                DataWriteField(emess_dbid,rec_id,6,(strlen(sent_subject[i]) + 1),sent_subject[i]);
                DataWriteField(emess_dbid,rec_id,7,(strlen(sent_body[i]) + 1),sent_body[i]);
		DataCloseRecord(emess_dbid,rec_id);
	}

        DataDeleteRecord(emess_dbid, 3, TRUE);
        DataDeleteRecord(emess_dbid, 4, TRUE);


	DataCloseDB(emess_dbid);

	for (i = 0; i <5; i++)
	{
		qfree(inbox_date[i]);
		qfree(inbox_to[i]);
		qfree(inbox_from[i]);
		qfree(inbox_cc[i]);
		qfree(inbox_bcc[i]);
		qfree(inbox_subject[i]);
		qfree(inbox_body[i]);
		qfree(outbox_date[i]);
		qfree(outbox_to[i]);
		qfree(outbox_from[i]);
		qfree(outbox_cc[i]);
		qfree(outbox_bcc[i]);
		qfree(outbox_subject[i]);
		qfree(outbox_body[i]);
		qfree(draft_date[i]);
		qfree(draft_to[i]);
		qfree(draft_from[i]);
		qfree(draft_cc[i]);
		qfree(draft_bcc[i]);
		qfree(draft_subject[i]);
		qfree(draft_body[i]);
		qfree(sent_date[i]);
		qfree(sent_to[i]);
		qfree(sent_from[i]);
		qfree(sent_cc[i]);
		qfree(sent_bcc[i]);
		qfree(sent_subject[i]);
		qfree(sent_body[i]);
	}

}


#define INCOMPLETED     0
#define TONE_ALARM      1
#define VOICE_ALARM     2


void ToDoDatabaseInit()
{
        DatabaseID tdl_dbid;
	RecordID rec_id;
	SHORT i= 0;
//	UWORD byte_return;
//	BYTE *string1, *string2;
		
        BYTE completed_items[16];
        BYTE alarm_status[16];
        BYTE priority[16];
        BYTE *to_do_contents[16];
        BYTE *schedule_date[16];


	/* setting up data */
	for (i = 0; i <15; i++)
        {

                completed_items[i] = INCOMPLETED;
                }

        for (i = 0; i <15; i++)
        {
		alarm_status[i] = TONE_ALARM;
                }


	alarm_status[2] = VOICE_ALARM;
	alarm_status[5] = 0;
	alarm_status[7] = VOICE_ALARM;
	alarm_status[9] = VOICE_ALARM;
	alarm_status[10] = 0;
	alarm_status[11] = VOICE_ALARM;
	alarm_status[13] = VOICE_ALARM;

	priority[0] = 1;
	priority[1] = 2;
	priority[2] = 3;
	priority[3] = 4;
	priority[4] = 5;
	priority[5] = 5;
	priority[6] = 5;
	priority[7] = 5;
	priority[8] = 5;
	priority[9] = 5;
	priority[10] = 5;
	priority[11] = 5;
	priority[12] = 5;
	priority[13] = 5;
	priority[14] = 5;


	for (i = 0; i <15; i++)
	{	
                to_do_contents[i] = (BYTE*)qmalloc(50*sizeof(BYTE));
                schedule_date[i]  = (BYTE*)qmalloc(26*sizeof(BYTE));
	}

	strcpy(to_do_contents[0],"Scheduler is an powerful application");
	strcpy(to_do_contents[1],"Wendy");
	strcpy(to_do_contents[2],"Kenny");
	strcpy(to_do_contents[3],"David");
	strcpy(to_do_contents[4],"Kenni");
	strcpy(to_do_contents[5],"Yogi");
	strcpy(to_do_contents[6],"Fiona");
	strcpy(to_do_contents[7],"Brian");
	strcpy(to_do_contents[8],"Rosita");
	strcpy(to_do_contents[9],"Hi Hi");
	strcpy(to_do_contents[10],"U2");
	strcpy(to_do_contents[11],"Chucky");
	strcpy(to_do_contents[12],"CoCo");
	strcpy(to_do_contents[13],"Rubbish");
	strcpy(to_do_contents[14],"Trash");

	strcpy(schedule_date[0],"15/4");
	strcpy(schedule_date[1],"14/4");
	strcpy(schedule_date[2],"13/4");
	strcpy(schedule_date[3],"12/4");
	strcpy(schedule_date[4],"11/4");
	strcpy(schedule_date[5],"10/4");
	strcpy(schedule_date[6],"09/4");
	strcpy(schedule_date[7],"08/4");
	strcpy(schedule_date[8],"07/4");
	strcpy(schedule_date[9],"06/4");
	strcpy(schedule_date[10],"05/4");
	strcpy(schedule_date[11],"04/4");
	strcpy(schedule_date[12],"03/4");
	strcpy(schedule_date[13],"02/4");
	strcpy(schedule_date[14],"01/4");

	/* New Database */
	DataNewDB((BYTE*)("To Do List Database"),1,(BYTE*)("To Do List Application"),&tdl_dbid);
	/* Open Database and sort by priority */
	DataOpenDB(tdl_dbid,2,OPEN_RW);
	/* Open Database */
	for (i = 0;i<15;i++)
	{
		DataNewRecord(tdl_dbid, 0x00, 7, &rec_id);
		DataWriteField(tdl_dbid,rec_id,0,1,(BYTE*) &completed_items[i]);
		DataWriteField(tdl_dbid,rec_id,1,1,(BYTE*) &alarm_status[i]);
		DataWriteField(tdl_dbid,rec_id,2,1,(BYTE*) &priority[i]);
                DataWriteField(tdl_dbid,rec_id,3,(strlen(to_do_contents[i]) + 1),to_do_contents[i]);
                DataWriteField(tdl_dbid,rec_id,4,(strlen(schedule_date[i]) + 1),schedule_date[i]);
		DataWriteField(tdl_dbid,rec_id,5,1,(BYTE*)(""));
		DataWriteField(tdl_dbid,rec_id,6,1,(BYTE*)(""));
		DataCloseRecord(tdl_dbid,rec_id);
	}
	for (i = 0; i <15; i++)
	{
		qfree(to_do_contents[i]);
		qfree(schedule_date[i]);
	}

        DataCloseDB(tdl_dbid);
}
