/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   alaunch.h
Author(s)   :   Henry Fok
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   header file for Launch command code
Revision    :   1.1
Note        :   None
===========================================================================
*/


#include "include\gf.h"
#include "include\gotorec.h"
#include "include\battery.h"

//======================== Launch Command ===========================
#define LAUNCH_CMD_NORMAL_LAUNCH	0
#define LAUNCH_CMD_FIND				1
#define LAUNCH_CMD_GOTO_REC			2
#define LAUNCH_CMD_ALARM_HIT		3
#define LAUNCH_CMD_SYNC_START       4
#define LAUNCH_CMD_VOXMEMO_LAUNCH   5
#define LAUNCH_CMD_CAL_PEN          6
#define LAUNCH_CMD_BAT              7
#define LAUNCH_CMD_MODEM_CONNECT	8
#define LAUNCH_CMD_TODAY_SCH		9
