#ifndef _EXPDEF_H_
#define _EXPDEF_H_

#include "include\uifunc.h"
#include "include\uidef.h"
#include "include\ui.h"
#include "include\mmu.h"
#include "include\expense.h"

/******************************************************************
***************** EXPENSE TYPE DEFINES ****************************
******************************************************************/
#define		AIRFARE					0
#define		BREAKFAST				1
#define		BUS						2
#define		BUSINESS_MEALS			3
#define		CAR_RENTAL				4
#define		DINNER					5
#define		ENTRETAINMENT			6
#define		FAX						7
#define		GAS						8
#define		GIFTS					9
#define		HOTEL					10
#define		INCIDENTALS				11
#define		LAUNDRY					12
#define		LIMO					13
#define		LODIGING				14
#define		LUNCH					15
#define		MILEAGE					16
#define		PARKING					17
#define		POSTAGE					18
#define		SNACK					19
#define		SUBWAY					20
#define		SUPPLIES				21
#define		TAXI					22
#define		TELEPHONE				23
#define		TIPS					24
#define		TOLLS					25
#define		TRAIN					26
#define		OTHER					27
#define		EXPENSE_TYPE			100
/******************************************************************
***************** EXPENSE CURRENICES DEFINES ****************************
******************************************************************/
#define		AUSTRALIA_CURR			0
#define		AUSTRIA_CURR			1
#define		BELGIUM_CURR			2
#define		BRAZIL_CURR				3
#define		CANADA_CURR				4
#define		DENMARK_CURR			5
#define		EURO_CURR				6
#define		FINLAND_CURR			7
#define		FRANCE_CURR				8
#define		GERMANY_CURR			9
#define		HONG_KONG_CURR			10
#define		ICELAND_CURR			11
#define		IRELAND_CURR			12
#define		ITALY_CURR				13
#define		JAPAN_CURR				14
#define		LUXEMBOURG_CURR			15
#define		MEXICO_CURR				16
#define		NETHERLANDS_CURR		17
#define		NEW_ZEALAND_CURR		18
#define		NORWAY_CURR				19
#define		SPAIN_CURR				20
#define		SWEDEN_CURR				21
#define		SWITZERLAND_CURR		22
#define		UNITED_KINGDOM_CURR		23
#define		UNITED_STATES_CURR		24
#define		NONE_CURR				25
/******************************************************************
******************************************************************/
#define		NUM_FLODERS				50
#define		EXPENSE_NUM_FIELD	3
#define		F_DATE				0
#define		F_TYPE				1
#define		F_AMT				2


#define		EXPENSE_INVALID_REC_NUM		65534

#define		EXPENSE_CURR_REC_ID			0x80001000

#define		EXPENSE_MAIN_APP_SAVE		0x80001001
#define		F_PopupItemNum				0
#define		F_CatText					1
#define		F_CatHighlightInList		2
#define		F_prev_row_num				3
#define		F_prev_col_num				4
#define		F_NewItemNumInList			5
#define		F_DelItemNum				6
#define		F_dialogX_selected			7
#define		F_RenameCat					8
#define		F_ActiveTextboxID			9
#define		F_ActiveFormID				10
#define		F_ExpTextboxString			11
#define		F_ExpTextboxCharPos			12
#define		F_ExpKeypadInvisible		13
#define		F_LargeFontInEdcat			14


#define		EXPENSE_MDB_APP_SAVE		0x80001002
#define		F_ListHighlightStatus		0
#define		F_CatNum					1
#define		F_HighlightRecNumInList		2
#define		F_TotalRecordInCat			3
#define		F_NewItemNum				4
#define		F_RecIDInList_0				5
#define		F_NewExpense_rec_id			6
#define		F_Highlighted_rec_id		7
#define		F_UnDelete_rec_id			8


typedef struct
{
	BYTE	year;
	BYTE	mon;
	BYTE	day;
	BYTE	hr;
	BYTE	min;
	BYTE	sec;
} EXPENSE_DATE;


#endif
