/*	File        : LINK.CMD
 *	Version 	: 1.0
 *  Description : Link map
 *  Author      : Thomas Cheng
 *  Date 		: 20 March, 1998
 */

OUTPUT_FORMAT("ecoff-littlemips")
ENTRY(reset_exception)
/*ENTRY(Reset_Boot_Up)*/
/* AH: init memory first ENTRY(reset_exception) */

MEMORY
{
/*        FLASH   : org = 0x9FC90000, l = 1M    */
        FLASH   : org = 0x9FD50000, l = 1M
/*        RAM             : org = 0x80000100, l = 2M*/
        RAM             : org = 0x80001100, l = 2M
}

SECTIONS
{
	.atext :
	{
		_fatext = . ;
			obj/start.o(.text)
			obj/chkmem.o(.text)
			obj/memchk.o(.text)
            obj/HwInit.o(.text)
			*(.rdata)
		eatext = . ;
	} > FLASH
	.bss	:
	{
		_fbss = . ;
			*(.bss)
			*(COMMON)
			*(.common)
			*(.scommon)
		ebss = . ;
	} > RAM
	.btext :
	{
    	_fbtext = . ;
    		*(.text)
    	ebtext = . ;
	} > RAM
	.data	:
	{
		_fdata = . ;
			*(.data)
/*          *(.rdata)*/
		edata   = . ;
	} > RAM
	mem_alloc_start = . ;
}
