/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   s16.h
Author(s)   :   Jason Ngan
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application header file
Revision    :   1.1
Note        :   None
===========================================================================
*/              


#define S12_SIZE	837
#define S16_SIZE	133
#define S17_SIZE	265
#define S131_SIZE	265

static BYTE S16[S16_SIZE] = {

  0,	 30,	 -2,	 -8,	  8,	
 85,	 93,	 95,	 -1,	 -1,	
 -3,	 85,	 85,	 -9,	 -1,	
 -1,	 85,	 85,	-14,	 -2,	
-66,	-43,	 21,	-69,	 62,	
-113,	-91,	-123,	 78,	 47,	
-117,	-91,	 97,	 75,	-97,	
-94,	-15,	 97,	 72,	 -6,	
 -8,	 65,	 78,	-66,	-72,	

 30,	-14,	 10,	 -1,	 85,	
 82,	-65,	-18,	 16,	 86,	
 15,	-81,	  3,	 86,	  7,	
-50,	-125,	-108,	-57,	-30,	
-91,	  5,	-93,	 -6,	-28,	
  5,	 34,	 -6,	-15,	 21,	
 95,	-29,	 80,	 -1,	-75,	
 83,	-68,	-43,	111,	-14,	
 84,	127,	-59,	 82,	

 20,	  8,	 -4,	-17,	-24,	
 97,	 78,	-72,	-124,	 63,	
-22,	 64,	-82,	 17,	 83,	
-66,	-60,	 87,	-86,	 64,	
122,	-83,	 81,	-104,	 -1,	
104,	 84,	 20,	 59,	 -6,	
 -2,	-22,	-127,	 85,	 67,	
118,	122,	 43,	-101,	-116,	
-118,	 21,	 80,	 26,	

};


static BYTE S131[S131_SIZE] = {

  0,	  2,	  5,	  0,	  0,	
-44,	 63,	-33,	 -1,	 -1,	
-33,	-11,	127,	-59,	 -6,	
-110,	 -4,	122,	-79,	120,	
-21,	-58,	 -1,	-86,	-66,	
  9,	 83,	-81,	-16,	-49,	
-58,	 23,	-63,	107,	 -8,	
 15,	-16,	  0,	-124,	 63,	
-49,	 -3,	 27,	-32,	  5,	

  3,	  0,	-10,	 -1,	 -7,	
-97,	-66,	-90,	 16,	 21,	
 -3,	126,	-128,	107,	 -3,	
 78,	 95,	-63,	-30,	-127,	
-76,	 59,	 87,	-53,	-78,	
-117,	-64,	107,	-12,	 -3,	
 61,	 59,	 44,	107,	 91,	
-48,	 42,	-58,	-109,	-20,	
 -7,	126,	 78,	-82,	

  3,	 -1,	 -7,	  3,	 35,	
 87,	-11,	-23,	 40,	 45,	
127,	-22,	 30,	 70,	-79,	
-96,	126,	 70,	-117,	 91,	
-56,	-64,	-82,	 -7,	126,	
 69,	 63,	  0,	127,	 44,	
 11,	-57,	-25,	-75,	125,	
 59,	-62,	-28,	 76,	 47,	
125,	-88,	 57,	-79,	

  7,	 -7,	 -3,	  2,	-112,	
-75,	-25,	-21,	111,	  2,	
 70,	 86,	-44,	 -7,	-58,	
-88,	-43,	 75,	-109,	-39,	
-84,	 22,	 -3,	125,	 85,	
113,	-76,	-107,	-20,	127,	
 92,	-66,	 70,	-15,	106,	
 95,	-59,	125,	-123,	 74,	
-81,	 85,	-11,	-17,	

 13,	-11,	 -2,	 -5,	-18,	
 -4,	  1,	-70,	 31,	-12,	
 16,	108,	 43,	-41,	 -4,	
 31,	-30,	 10,	-65,	 80,	
-67,	 79,	-44,	 42,	-59,	
 90,	-37,	-127,	122,	 78,	
-67,	  2,	-81,	-59,	 63,	
 66,	 17,	 34,	  0,	 -5,	
  7,	-22,	-63,	 58,	

 15,	  5,	  0,	  7,	-48,	
-80,	 79,	-43,	-32,	120,	
 61,	106,	103,	 -1,	 -6,	
-69,	 -4,	  2,	-73,	-86,	
 43,	 -1,	 -6,	 -1,	  0,	
-81,	 45,	-29,	-88,	 -3,	
 95,	-47,	-10,	-87,	 23,	
 -3,	 93,	 81,	-72,	-79,	
-11,	-19,	 95,	 87,	

};


static BYTE S17[S17_SIZE] = {
	
  0,	  2,	  0,	  2,	  0,	
112,	 85,	 31,	 -1,	 21,	
 84,	 96,	 15,	-59,	 85,	
-127,	-63,	 84,	 31,	 -1,	
 -1,	-18,	-16,	 85,	 85,	
  0,	 11,	 11,	123,	-79,	
-13,	-37,	 -2,	 85,	 85,	
 86,	 -3,	 -1,	 -2,	-64,	
 92,	 76,	 40,	109,	-128,	

 12,	 -5,	  2,	  1,	 55,	
 48,	 64,	 16,	 81,	 95,	
-43,	 81,	 79,	-12,	-49,	
 95,	 93,	 -3,	 37,	113,	
 -3,	 93,	 85,	126,	111,	
 -2,	-61,	-111,	-11,	 87,	
-81,	 -5,	-88,	 84,	-18,	
 85,	 63,	-82,	-68,	 80,	
-27,	127,	 -7,	-61,	

 15,	 -3,	  0,	 -2,	 -8,	
 13,	 60,	 83,	-107,	 45,	
 43,	 -1,	-36,	  0,	 69,	
-128,	 54,	-23,	 15,	 95,	
 -8,	112,	 21,	 87,	-97,	
-82,	 27,	-62,	-39,	 92,	
-86,	 -1,	-105,	-88,	 65,	
  1,	 80,	-28,	122,	-23,	
-17,	-92,	 45,	 13,	

 14,	  2,	  3,	 -1,	 68,	
-124,	 37,	 22,	-65,	 47,	
-20,	 75,	 44,	 14,	-60,	
 18,	  0,	 88,	-83,	127,	
-81,	 -5,	 81,	 64,	 87,	
 89,	-126,	-86,	-87,	 61,	
103,	 -3,	-86,	-48,	-86,	
-43,	 79,	 11,	-126,	-63,	
 84,	-117,	 47,	 -2,	

  5,	  0,	 -1,	  0,	 21,	
-26,	-65,	-31,	  5,	 85,	
 82,	-81,	-85,	-23,	 24,	
 12,	 21,	 74,	-109,	  6,	
-78,	 90,	-55,	 89,	 59,	
-13,	-81,	-114,	-85,	 67,	
 53,	 83,	 -5,	 80,	105,	
-97,	-82,	-88,	  5,	 43,	
 81,	 85,	 72,	 31,	

 12,	  1,	 -1,	  0,	-22,	
-81,	-69,	-66,	 64,	 21,	
 80,	 20,	-21,	-82,	-66,	
-18,	-11,	 96,	  4,	-43,	
 95,	126,	-65,	 83,	-63,	
-37,	 89,	121,	-33,	-18,	
 73,	 65,	  4,	  6,	112,	
-67,	 -1,	-112,	 18,	-102,	
-69,	  7,	 82,	 16,	

};

static BYTE S12[S12_SIZE] = {
	
  0,	  9,	  7,	  0,	 -4,	
-11,	 85,	 95,	125,	127,	
 85,	 95,	 -3,	127,	 -9,	
-35,	-41,	117,	 85,	 81,	
 -6,	-65,	-17,	-82,	-103,	
  0,	 22,	 83,	100,	-48,	
 12,	 85,	 -6,	-67,	-11,	
 21,	110,	-43,	 -1,	-44,	
 -4,	 85,	  0,	 23,	 -1,	

 16,	  0,	  4,	  4,	-58,	
-75,	119,	-11,	-34,	 21,	
-43,	 65,	-14,	-25,	 -9,	
-109,	-33,	 81,	106,	-107,	
 84,	-15,	 -9,	-17,	 -1,	
-60,	 85,	 85,	 85,	 20,	
 43,	-45,	 95,	 -1,	 -1,	
 -6,	-65,	  5,	  1,	 85,	
 84,	 85,	 82,	  1,	

 27,	  5,	 11,	 -9,	 96,	
  7,	 -1,	 -6,	-126,	-28,	
-101,	109,	 85,	  2,	 20,	
-94,	 90,	 95,	-66,	-65,	
-86,	 81,	-84,	-113,	  6,	
-107,	101,	105,	 42,	-70,	
 -7,	 91,	-23,	 37,	 67,	
 -4,	114,	 36,	-127,	  0,	
 -1,	-82,	 -1,	 18,	

 30,	 12,	  0,	 -5,	-44,	
-111,	 88,	 24,	-88,	111,	
-25,	-118,	-88,	 -1,	 -1,	
-64,	 41,	 85,	 84,	 33,	
 66,	  2,	 26,	 -3,	 -1,	
 -2,	 59,	-120,	 72,	 80,	
 84,	  5,	 73,	 11,	-15,	
 63,	  2,	-79,	 63,	 -6,	
-87,	121,	 95,	 85,	

 20,	  4,	 -1,	 -1,	 22,	
-23,	 57,	-19,	-10,	 -3,	
 81,	-12,	 49,	 -2,	-44,	
 61,	  2,	 84,	 65,	103,	
 -1,	-55,	 73,	 67,	-14,	
-24,	-65,	-75,	 84,	-98,	
 51,	 69,	 87,	 -6,	-119,	
 95,	-21,	 -6,	-62,	121,	
-27,	 81,	  5,	 17,	

 23,	  2,	 -1,	  3,	 70,	
-17,	-24,	  4,	-114,	-44,	
 -7,	 42,	  9,	-91,	111,	
-71,	-105,	 -6,	-65,	-82,	
 46,	 91,	 64,	 60,	 64,	
 20,	  1,	 85,	 96,	-120,	
 -1,	 -1,	-62,	-44,	-108,	
 20,	 43,	-96,	-11,	 64,	
 47,	-82,	-32,	 -1,	

 19,	  5,	  2,	  3,	-21,	
-82,	 58,	 30,	-91,	 80,	
  2,	-27,	 85,	 20,	  0,	
 40,	 43,	 82,	 -1,	 -1,	
-20,	 84,	  0,	 21,	 84,	
 10,	127,	-14,	-65,	-96,	
-70,	-88,	 62,	-59,	 85,	
  4,	 40,	 84,	 71,	-17,	
-66,	-81,	-32,	  0,	

 12,	 10,	  4,	  3,	 85,	
 85,	 64,	 80,	 20,	 10,	
-65,	 -1,	 -5,	 -6,	-86,	
  5,	 71,	-92,	  1,	 32,	
  2,	-31,	 -1,	 -2,	 42,	
 21,	 79,	-43,	 80,	-87,	
-15,	 80,	  5,	 82,	-127,	
 75,	 -1,	 -1,	-96,	-66,	
-107,	  0,	 10,	126,	

 11,	  7,	  4,	  2,	-82,	
-82,	-17,	 -8,	 90,	-22,	
-65,	 -1,	-118,	-123,	 88,	
 85,	 80,	  4,	 20,	  7,	
 -1,	 -1,	-88,	 13,	 65,	
  0,	 42,	-128,	 -1,	-81,	
 -1,	-24,	 42,	 85,	 39,	
-22,	 85,	 85,	 80,	 64,	
  5,	 72,	 47,	 -1,	

 17,	  9,	  3,	  2,	-62,	
-93,	 84,	-95,	 84,	  0,	
-70,	126,	-65,	-85,	-86,	
127,	 -1,	-88,	  4,	-86,	
 85,	 64,	 21,	  0,	  2,	
 -1,	-22,	 -2,	-81,	 -4,	
 85,	 66,	-66,	-48,	 -2,	
-86,	 42,	-127,	 85,	 84,	
 63,	 -6,	-88,	 16,	

  4,	  5,	  4,	  3,	 10,	
 20,	 -1,	 -1,	-94,	122,	
-21,	 21,	 85,	 85,	 85,	
 10,	-70,	 -6,	 -2,	 -6,	
-125,	  0,	 40,	-21,	 -1,	
 -1,	-84,	 81,	 85,	  0,	
  0,	-97,	 -6,	-65,	-81,	
 -6,	 19,	-21,	 84,	-96,	
 85,	 47,	-96,	  5,	

  8,	 -2,	  5,	  2,	 80,	
 38,	 -2,	-44,	 63,	 -1,	
 -2,	-18,	-127,	 14,	 64,	
  5,	  0,	106,	-79,	 81,	
-96,	 64,	 84,	 -1,	 -7,	
 75,	 -6,	 -6,	 84,	 62,	
-86,	 -6,	-94,	-59,	 85,	
 84,	-21,	  3,	-65,	 -1,	
-21,	-66,	-124,	 85,	

  4,	  3,	  1,	  2,	 64,	
-68,	 20,	  8,	106,	 64,	
 31,	-22,	-85,	 -2,	-66,	
-87,	-63,	 64,	 21,	 82,	
 -1,	-86,	-81,	-23,	  0,	
  4,	  5,	 95,	 -1,	 -5,	
 -6,	-86,	-90,	-80,	 85,	
 85,	 85,	 64,	  4,	  1,	
 -6,	 -1,	 -5,	-22,	

  0,	  1,	  1,	  2,	-86,	
-80,	 21,	  2,	-96,	-82,	
112,	  0,	 62,	-16,	 63,	
 -6,	-65,	 -1,	-86,	 21,	
 84,	  1,	 -1,	 -1,	-22,	
-82,	 -2,	-85,	  0,	  1,	
 84,	  0,	  0,	 16,	 84,	
-65,	 -1,	 -1,	 -1,	 -1,	
-18,	-96,	 21,	 80,	

  5,	  1,	  0,	  7,	  1,	
 68,	 80,	 10,	-88,	 11,	
-22,	-66,	-21,	 19,	-64,	
 62,	 -1,	 -1,	 -2,	-82,	
-111,	 68,	-72,	 85,	 21,	
 64,	 66,	-17,	 -2,	-17,	
-65,	-22,	-86,	-127,	 85,	
 17,	 66,	-114,	-70,	 -1,	
 -1,	 -2,	-81,	-70,	

  2,	  0,	 -4,	  1,	-84,	
 32,	-32,	 21,	 85,	 85,	
 64,	  0,	  6,	 -1,	-84,	
-69,	-23,	  1,	-81,	  0,	
 47,	 -2,	-74,	-96,	 80,	
111,	  1,	 79,	 -1,	-82,	
 -6,	-54,	 -6,	-54,	 63,	
 -1,	 -2,	-22,	-127,	 85,	
 85,	 67,	-65,	-21,	

  1,	 -2,	  1,	  1,	-69,	
-84,	  0,	  1,	 84,	-17,	
 -1,	-65,	-22,	-96,	 81,	
  0,	107,	 -1,	 -6,	-86,	
  0,	 85,	 10,	-18,	 61,	
-82,	-17,	-18,	-64,	  0,	
 85,	 67,	-18,	 -2,	-87,	
  2,	 64,	  0,	 12,	-107,	
 83,	 -1,	 -1,	 -1,	

  3,	  0,	  0,	  0,	 -2,	
-68,	  5,	 64,	  0,	-113,	
-66,	 -6,	-101,	-70,	 69,	
 15,	-66,	-104,	-128,	  3,	
 -1,	-64,	  7,	 -1,	 -5,	
-65,	-23,	  1,	 69,	 84,	
 14,	 -1,	 -1,	 -5,	-86,	
-86,	-90,	-56,	-21,	-104,	
 64,	  0,	 85,	 85,	

  2,	 -2,	  2,	  2,	 47,	
-69,	-50,	 -1,	 -2,	-18,	
-24,	  2,	 35,	 32,	  1,	
 81,	 85,	 43,	 -1,	-65,	
 -1,	-22,	-86,	-69,	-68,	
  5,	-112,	 26,	-96,	  3,	
 -1,	 64,	-120,	 15,	 -1,	
 -1,	 -1,	-92,	  8,	-97,	
 -1,	 -1,	 -1,	 -1,	

};	