/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   uidef.h
Author(s)   :   Henry Fok, David Lo
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   header file for ui event
Revision    :   1.1
Note        :   None
===========================================================================
*/              


#ifndef __UIEVENT_H_
#define __UIEVENT_H_

#define     EVT_APP_STOP		            100
#define     EVT_APP_LAUNCH		            101
#define	  	EVT_FORM_OPEN					51
#define	  	EVT_FORM_CLOSE					52
#define   	EVT_FORM_LOAD	    			53
#define		EVT_FORM_SAVE					54
#define		EVT_CONTROL_SELECT				55
#define		EVT_CONTROL_ENTER				56
#define		EVT_CONTROL_REPEAT				57
#define		EVT_CONTROL_POPUP_SELECT		58
#define		EVT_CONTROL_EXIT				59
#define		EVT_FIELD_CHANGED				60
#define		EVT_FIELD_ENTER					61
#define		EVT_FIELD_HEIGHT				62
#define		EVT_LIST_ENTER					63
#define		EVT_LIST_EXIT					64
#define		EVT_LIST_SELECT					65
#define		EVT_MENU_ENTER					66
#define		EVT_MENU_SELECT_ITEM			67
#define		EVT_MENU_SELECT					68
#define		EVT_MENU_EXIT					69
#define		EVT_SCROLLBAR_ENTER				70
#define		EVT_SCROLLBAR_REPEAT			71
#define		EVT_SCROLLBAR_EXIT				72
#define	  	EVT_TABLE_ENTER					73
#define		EVT_TABLE_SELECT				74
#define		EVT_TABLE_EXIT					75
#define		EVT_BITMAP_ENTER				76
#define		EVT_BITMAP_SELECT				77
#define		EVT_BITMAP_EXIT					78
#define     EVT_LIST_ARROW                  79
#define     EVT_SCROLLBAR_SELECT            80
#define		EVT_FIELD_SELECT				81
#define		EVT_KEYBOARD_ENTER				82
#define		EVT_KEYBOARD_EXIT				83
#define		EVT_KEYBOARD_STATUS				84
#define		EVT_SCHLINE_ENTER				85
#define		EVT_SCHLINE_EXIT				86
#define		EVT_SCHLINE_SELECT				87
#define		EVT_TEXTBOX_ENTER				88
#define		EVT_TEXTBOX_SELECT				89
#define		EVT_TEXTBOX_CHANGED				90
#define     EVT_FIELD_MODIFIED              91
#define     EVT_TEXTBOX_MODIFIED            92
#define     EVT_SCROLLBAR_ARROW_DELAY       93
#define     EVT_SCROLLBAR_ENTER_REPEAT      94
#define     EVT_FIELD_JOT_PASTE_STRING      95
#define     EVT_TEXTBOX_JOT_PASTE_STRING    96
#define 	EVT_FORM_ACTIVE					97
#define 	EVT_FORM_INACTIVE				98

#endif
