#ifndef __TODOFUNC_H_
#define __TODOFUNC_H_

#include "include\uifunc.h"
#include "include\ui.h"
#include "include\mmu.h"
#include "include\SySetup.h"
#include "include\Memo.h"
#include "include\MemoDB.h"

/*****************************************************************
********************** Global Variables **************************
*****************************************************************/
extern DatabaseID		memo_dbid;
extern BYTE **			memo_field_buffer;
extern BYTE 			memo_text_buffer[5];
extern TableDisplay		memo_list;
extern AppStatus		app_status;
extern BYTE				font_size;
extern ObjectID			pressed_key;


/*****************************************************************
********************** To Do List Application ********************
*****************************************************************/
BOOLEAN MemoSetTableTopRowNum(UWORD top_record);
BOOLEAN MemoSetScrollbar();
BOOLEAN MemoDisplayGetRecordID(TableDisplay *table_display, USHORT row_num,RecordID *rec_id, DatabaseID *dbid);
BOOLEAN MemoSetUpFieldScreen(ObjectID form_id);
BOOLEAN MemoEditSetField(ObjectID form_id, ObjectID field_id);
BOOLEAN MemoFieldSetScrollbar(ObjectID field_id, ObjectID scrollbar_id);
BOOLEAN MemoChangeFont();
BOOLEAN MemoEditCateSetScrollbar();
BOOLEAN DeleteCateCheck(SHORT selected_item);
BOOLEAN DeleteCate(SHORT selected_item);
BOOLEAN MemoInputCatCheckCharIn();
void MemoScrollbarSetTable(EvtType *Event);
void MemoRecordToVariable();
void MemoViewingSetUpScreen();
void MemoInitFieldBuffer();
void MemoFieldToFieldBuffer();
void MemoFieldBufferToField();
void MemoClearFieldBuffer();
void MemoMenuSelectedAction(USHORT item_num);
void MemoScrollbarSetField(ObjectID field_id, ObjectID scrollbar_id, EvtType *Event);
void MemoScrollbarSetEditCate(EvtType *Event);
void MemoCateNameToPopupTrigger(DatabaseID dbid);
Err MemoGetClickedCell(ObjectID table_id,SHORT x_coord,SHORT y_coord,USHORT *row_number,
					   USHORT *col_number,USHORT *cell_number);

#endif
